
 #include <LPC21xx.H>
 #include <stdio.h> 
 #include <string.h>
#define MAX_RX 64;
#define MAX_TX 64;

const unsigned char HDIGIT[16] = "0123456789ABCDEF";

unsigned char UARTRXBuff[64];
unsigned char UARTTXBuff[64];
unsigned char UARTTXsize;
unsigned char UARTTXindex;
unsigned char UARTRXsize;
unsigned char UARTRXindex;
unsigned char UART_TX_Complete;
unsigned char UART_RX_Complete;
//==========================================================================

__irq void UART_Handler (void){
unsigned int idval;
	idval=U1IIR;
	idval=(idval & 0x0F) >> 1;
switch (idval) {
case 0x01: //TX buffer empty
	if (UARTTXsize>0)
	{
	U1THR=UARTTXBuff[UARTTXindex];
	UARTTXindex ++;
	UARTTXsize  --;	
	 }else
	  U1IER=0x05; 
break;
case 0x02:
case 0x06: //RX buffer empty
	while (U0LSR & 0x01) {
	if (UARTRXindex < 64){	
  	UARTRXBuff[UARTRXindex]=U0RBR;
	UARTRXindex++;
	}
	else UART_RX_Complete=1;
	}
break;
default: //
//
break;
};
VICVectAddr=0;
}
//================================================================================

void InitUART(unsigned int baud)
{
	 U1LCR = 0x87; 
	 U1DLL = 0x61;  
	 U1DLM = 0;
	 U1FDR = 0x10;
	 U1LCR=0x03; 
	 U1FCR=0xC7; //0b11000111
	 U1IER=0x05;
	 U1TER=0x80;
	 
	 PINSEL0 = 0x00050000; 
	 VICVectCntl6=0x27; //
	 VICVectAddr6=(unsigned)UART_Handler;
	 VICIntEnable = (1 << 7); // UART interrupt	 
}

//==========================================================================

void UARTTXBegin(void)
{
    U1FCR=0xC7; //0b11000111
	U1IER=0x07; //  TX empty
	U1THR=UARTTXBuff[0];
	UARTTXindex = 1;
	UARTTXsize --;	
}
//==========================================================================

void SendPacket(unsigned char *Buff, unsigned char cnt)
{
	memcpy(UARTTXBuff, Buff, cnt);
	UARTTXsize = cnt;
	UARTTXBegin();
}
//==========================================================================

void AddTXBuffer(unsigned char data)
{
	UARTTXBuff[UARTTXsize] = data;
	UARTTXsize ++;	
}
//==========================================================================

void build_8h(unsigned char data)
{
static unsigned char lbyte,hbyte;
	lbyte = data&0x0F;
	AddTXBuffer(HDIGIT[lbyte]);	
	hbyte = data>>4;
	AddTXBuffer(HDIGIT[hbyte]);
}
//==========================================================================

void build_16h(unsigned int data)
{
	build_8h(data>>8);
	build_8h(data&0xFF);
}
//==========================================================================

unsigned char recept_8h(void)
{
static unsigned  char lbyte,hbyte;
//	hbyte = 0x41;
//	lbyte = 0x43;	
	if (lbyte>57) lbyte-=55; else lbyte-=48;
	if (hbyte>57) hbyte-=55; else hbyte-=48;
	hbyte<<=4;
	hbyte+=lbyte;
	return hbyte;
}
//==========================================================================



